cascading.flow

## Interface FlowStep<Config>

- All Superinterfaces:
    ProcessModel
  All Known Implementing Classes:
    BaseFlowStep, Hadoop2TezFlowStep, HadoopFlowStep, LocalFlowStep, MapReduceFlowStep, ProcessFlowStep

      public interface FlowStep<Config>
      extends ProcessModel

  Class FlowStep is an internal representation of a given "job" possibly to be executed on a remote cluster. During planning, pipe assemblies are broken down into "steps" and encapsulated in this class.

  FlowSteps are submitted in order of dependency. If two or more steps do not share the same dependencies and all can be scheduled simultaneously, the `getSubmitPriority()` value determines the order in which all steps will be submitted for execution. The default submit priority is 5.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `CASCADING_FLOW_STEP_ID`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addListener(FlowStepListener flowStepListener)` Method addListener registers the given `FlowStepListener` with this instance.
    `boolean` | `containsPipeNamed(String pipeName)` Returns true if this FlowStep contains a pipe/branch with the given name.
    `Config` | `getConfig()` Method getConfig returns the current initialized configuration.
    `Map<Object,Object>` | `getConfigAsProperties()` Method getConfigAsProperties converts the internal configuration object into a `Map` of key value pairs.
    `Flow<Config>` | `getFlow()`
    `String` | `getFlowID()`
    `String` | `getFlowName()` Method getParentFlowName returns the parentFlowName of this FlowStep object.
    `FlowNodeGraph` | `getFlowNodeGraph()`
    `Map<String,String>` | `getFlowStepDescriptor()` Returns an immutable map of properties giving more details about the FlowStep object.
    `FlowStepStats` | `getFlowStepStats()`
    `Group` | `getGroup()`
    `String` | `getID()` Method getId returns the id of this FlowStep object.
    `String` | `getName()` Method getName returns the name of this FlowStep object.
    `int` | `getNumFlowNodes()`
    `int` | `getOrdinal()`
    `Tap` | `getSink()`
    `Set<String>` | `getSinkName(Tap sink)`
    `Tap` | `getSinkWith(String identifier)`
    `Set<String>` | `getSourceName(Tap source)`
    `Tap` | `getSourceWith(String identifier)`
    `String` | `getStepDisplayName()` Method getStepDisplayName returns the stepDisplayName of this FlowStep object.
    `int` | `getSubmitPriority()` Method getSubmitPriority returns the submitPriority of this FlowStep object.
    `Tap` | `getTrap(String name)`
    `Set<Tap>` | `getTraps()`
    `boolean` | `hasListeners()` Method hasListeners returns true if `FlowStepListener` instances have been registered.
    `boolean` | `removeListener(FlowStepListener flowStepListener)` Method removeListener removes the given flowStepListener from this instance.
    `void` | `setFlowStepStats(FlowStepStats flowStepStats)`
    `void` | `setSubmitPriority(int submitPriority)` Method setSubmitPriority sets the submitPriority of this FlowStep object.

    - ### Methods inherited from interface cascading.flow.planner.process.ProcessModel

      `addProcessAnnotation, addProcessAnnotation, getElementGraph, getGroups, getProcessAnnotations, getSinkElements, getSinkTaps, getSourceElements, getSourceTaps, getTrapMap`

- - ### Field Detail

    - #### CASCADING_FLOW_STEP_ID

          static final String CASCADING_FLOW_STEP_ID

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getID

          String getID()

      Method getId returns the id of this FlowStep object.
      Specified by:
        `getID` in interface `ProcessModel`
      Returns:
        the id (type int) of this FlowStep object.

    - #### getOrdinal

          int getOrdinal()

      Specified by:
        `getOrdinal` in interface `ProcessModel`

    - #### getName

          String getName()

      Method getName returns the name of this FlowStep object.
      Specified by:
        `getName` in interface `ProcessModel`
      Returns:
        the name (type String) of this FlowStep object.

    - #### getFlowStepDescriptor

          Map<String,String> getFlowStepDescriptor()

      Returns an immutable map of properties giving more details about the FlowStep object.

      FlowStep descriptions provide meta-data to monitoring systems describing the workload a given FlowStep represents. For known description types, see `FlowStepDescriptors`.
      Returns:
        Map

    - #### getFlow

          Flow<Config> getFlow()

    - #### getFlowID

          String getFlowID()

    - #### getFlowName

          String getFlowName()

      Method getParentFlowName returns the parentFlowName of this FlowStep object.
      Returns:
        the parentFlowName (type Flow) of this FlowStep object.

    - #### getConfig

          Config getConfig()

      Method getConfig returns the current initialized configuration.

      The returned configuration is mutable and may be changed prior to this step being started or submitted.
      Returns:
        the current initialized configuration

    - #### getConfigAsProperties

          Map<Object,Object> getConfigAsProperties()

      Method getConfigAsProperties converts the internal configuration object into a `Map` of key value pairs.
      Returns:
        a Map of key/value pairs, may return an empty collection if unsupported

    - #### getStepDisplayName

          String getStepDisplayName()

      Method getStepDisplayName returns the stepDisplayName of this FlowStep object.
      Returns:
        the stepName (type String) of this FlowStep object.

    - #### getSubmitPriority

          int getSubmitPriority()

      Method getSubmitPriority returns the submitPriority of this FlowStep object.

      10 is lowest, 1 is the highest, 5 is the default.
      Specified by:
        `getSubmitPriority` in interface `ProcessModel`
      Returns:
        the submitPriority (type int) of this FlowStep object.

    - #### setSubmitPriority

          void setSubmitPriority(int submitPriority)

      Method setSubmitPriority sets the submitPriority of this FlowStep object.

      10 is lowest, 1 is the highest, 5 is the default.
      Parameters:
        `submitPriority` - the submitPriority of this FlowStep object.

    - #### getFlowNodeGraph

          FlowNodeGraph getFlowNodeGraph()

    - #### getNumFlowNodes

          int getNumFlowNodes()

    - #### getGroup

          Group getGroup()

    - #### getSink

          Tap getSink()

    - #### getSourceName

          Set<String> getSourceName(Tap source)

    - #### getSinkName

          Set<String> getSinkName(Tap sink)

    - #### getSourceWith

          Tap getSourceWith(String identifier)

    - #### getSinkWith

          Tap getSinkWith(String identifier)

    - #### getTraps

          Set<Tap> getTraps()

    - #### getTrap

          Tap getTrap(String name)

    - #### containsPipeNamed

          boolean containsPipeNamed(String pipeName)

      Returns true if this FlowStep contains a pipe/branch with the given name.
      Parameters:
        `pipeName` - the name of the Pipe
      Returns:
        a boolean

    - #### setFlowStepStats

          void setFlowStepStats(FlowStepStats flowStepStats)

    - #### getFlowStepStats

          FlowStepStats getFlowStepStats()

    - #### hasListeners

          boolean hasListeners()

      Method hasListeners returns true if `FlowStepListener` instances have been registered.
      Returns:
        boolean

    - #### addListener

          void addListener(FlowStepListener flowStepListener)

      Method addListener registers the given `FlowStepListener` with this instance.
      Parameters:
        `flowStepListener` - of type flowStepListener

    - #### removeListener

          boolean removeListener(FlowStepListener flowStepListener)

      Method removeListener removes the given flowStepListener from this instance.
      Parameters:
        `flowStepListener` - of type FlowStepListener
      Returns:
        true if the listener was removed

Copyright © 2007-2015 Concurrent, Inc. All Rights Reserved.